<?php
namespace Teknisa\EST\Factories;

use Doctrine\ORM\EntityManager;

class Est33000RequisicaoEstoqueFactory {
    #default service
    protected $connection;

    /* **************************************************
     * Construtor da Factory.
     *
     * @param EntityManager $entityManager
     */
    
    public function __construct(EntityManager $entityManager) {
        #initializes default service
        $this->connection = $entityManager->getConnection();
    }
    
    public function getNrSequItem($cdfilial, $nrrequesto) {
        $sql = "SELECT NVL  (         LPAD(TO_CHAR(MAX(NRSEQUITEM) + 1),4,'0')  ,  LPAD(TO_CHAR(1),4,'0' ) ) AS NRSEQUITEM
                FROM ITREQUESTO
                WHERE
                    CDFILIAL = :P_CDFILIAL
                    AND NRREQUESTO LIKE :P_NRREQUESTO";
        $params = array(
            'P_CDFILIAL'=>$cdfilial,
            'P_NRREQUESTO'=>$nrrequesto
        );

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function updateProduto($row){
        try {
            $sql = "UPDATE ITREQUESTO 
                      SET QTREQUESTO  = :QTREQUESTO,
                        NRLOTEESTQ  = :NRLOTEESTQ,
                        NRSUBLOTE   = :NRSUBLOTE
                          WHERE (NRORG       = :NRORG)
                            AND (NRSEQITEM   = :NRSEQITEM)
                            AND (CDFILIAL    = :CDFILIAL)
                            AND (NRREQUESTO  = :NRREQUESTO)
                            AND (CDPRODUTO   = :CDPRODUTO)";
                     
            $params = array(
                'QTREQUESTO'=>$row['QTREQUESTO'],
                'NRLOTEESTQ'=>$row['NRLOTEESTQ'],
                'NRSUBLOTE'=>$row['NRSUBLOTE'],
                'NRORG'=>$row['NRORG'],
                'NRSEQITEM'=>$row['NRSEQITEM'],
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRREQUESTO'=>$row['NRREQUESTO'],
                'CDPRODUTO'=>$row['CDPRODUTO']
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    

}