/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_COMANDAFOS                                               */
/* Tabela : COMANDAFOS                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 29/05/2007 - Blenet Ferreira Simes                                        */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_COMANDAFOS' and
            type = 'TR'                  and
            u.uid = o.uid                and
            u.name = USER)
   DROP TRIGGER DTULTATU_COMANDAFOS
GO

CREATE TRIGGER DTULTATU_COMANDAFOS
ON COMANDAFOS
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'COMANDAFOS', CDFILIAL, 'CDFILIAL='+ CDFILIAL+ ';'+ 'CDLOJA='+ CDLOJA+ ';'+ 'DSCOMANDAFOS='+ DSCOMANDAFOS+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE COMANDAFOS
      SET DTULTATUCOMANDA = GETDATE()
      FROM INSERTED
      WHERE  (ISNULL(COMANDAFOS.CDFILIAL,0)        = ISNULL(INSERTED.CDFILIAL,0))
         AND (ISNULL(COMANDAFOS.CDLOJA,0)          = ISNULL(INSERTED.CDLOJA,0))
         AND (ISNULL(COMANDAFOS.DSCOMANDAFOS,0)    = ISNULL(INSERTED.DSCOMANDAFOS,0))
         AND (ISNULL(COMANDAFOS.DSOBSCOMANDAFOS,0) = ISNULL(INSERTED.DSOBSCOMANDAFOS,0))
         AND (ISNULL(COMANDAFOS.IDSITCOMANDAFOS,0) = ISNULL(INSERTED.IDSITCOMANDAFOS,0))
         AND (ISNULL(COMANDAFOS.DTSITCOMANDAFOS,0) = ISNULL(INSERTED.DTSITCOMANDAFOS,0))
         AND (ISNULL(COMANDAFOS.CDOPERADOR,0)      = ISNULL(INSERTED.CDOPERADOR,0));
   END;
END;
GO

-- VERSAO --
--EXEC ATUVEROBJ 'DTULTATU_COMANDAFOS','4.11.132';
--GO
