/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8440_SUPSTPS.sql

Descrio:
Apura as melhores cotaes considerando produto preferencial, particularidades,
acordos, lista de preos e cotao de preos

Criao:
31/10/2003 - Adriano de Arajo

IDMOTIVPRESC[1]
  '0' - Sem produto preferencial
  '1' - Escolhido produto preferencial
IDMOTIVPRESC[2]
  '0' - Sem particularidade de fornecedor/marca
  '7' - Escolhido por fornecedor/marca obrigatrios
  '8' - Escolhido por fornecedor/marca preferenciais
  '9' - Escolhido por fornecedor/marca restritivos
IDMOTIVPRESC[3]
  '0' - Sem particularidade de fornecedor
  '4' - Escolhido por fornecedor obrigatrio
  '5' - Escolhido por fornecedor preferencial
  '6' - Escolhido por fornecedor restritivo
  'A' - Escolhido por acordo
IDMOTIVPRESC[4]
  '0' - Sem particulariade de marca
  '1' - Escolhido por marca obrigatria
  '2' - Escolhido por marca preferencial
  '3' - Escolhido por marca restritiva
IDMOTIVPRESC[5]
  '1' - Escolhido da lista de preos
  '2' - Escolhido de cotao fora de lista
IDMOTIVPRESC[6]
  '0' - Apurao normal
  '1' - Apurao para solicitaes extras - Fornecedor escolhido no  extra
  '2' - Apurao para solicitaes extras - Fornecedor escolhido  extra
  '3' - Apurao para solicitaes no extras
*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE
            O.NAME = 'APURA_MELHOR_COTACAO' AND
            TYPE = 'P'                      AND
            U.UID = O.UID                   AND
            U.NAME = USER)

   DROP PROCEDURE APURA_MELHOR_COTACAO;
GO

CREATE PROCEDURE APURA_MELHOR_COTACAO
(
   @P_CDCENTCMP  VARCHAR(4),
   @P_NRSEQAPUR  VARCHAR(10),
   @P_SISTEMA    VARCHAR(3),
   @P_TIPO       VARCHAR(1)
)
AS
DECLARE @V_IDTIPOAPUR VARCHAR(1);

DECLARE @V_REGIAO_CDREGITMAP   VARCHAR(4);
DECLARE @V_REGIAO_CDPRODITMAP  VARCHAR(10);
DECLARE @V_REGIAO_CDPRODESTO   VARCHAR(10);
DECLARE @V_REGIAO_IDFUNCAOFILI VARCHAR(1);
DECLARE @V_REGIAO_CDFILIAP     VARCHAR(4);
DECLARE @V_REGIAO_DTENTRAPUT   DATETIME;
DECLARE @V_REGIAO_CDPAIS       VARCHAR(4);
DECLARE @V_REGIAO_SGESTADO     VARCHAR(2);
DECLARE @V_REGIAO_CDMUNICIPIO  VARCHAR(4);
DECLARE @V_ITMAPURPREC_CDCENTITMAP  VARCHAR(4);
DECLARE @V_ITMAPURPREC_NRSEQITMAP   VARCHAR(10);
DECLARE @V_ITMAPURPREC_CDREGITMAP   VARCHAR(3);
DECLARE @V_ITMAPURPREC_CDFORNITMAP  VARCHAR(21);
DECLARE @V_ITMAPURPREC_NRCOLEITMAP  VARCHAR(10);
DECLARE @V_ITMAPURPREC_DTENTRAPUT   DATETIME;
DECLARE @V_ITMAPURPREC_CDFILIAP     VARCHAR(4);
DECLARE @V_ITMAPURPREC_CDPRODITMAP  VARCHAR(10);
DECLARE @V_ITMAPURPREC_CDMARCITMAP  VARCHAR(5);
DECLARE @V_ITMAPURPREC_IDMOTIVPRESC VARCHAR(10);
DECLARE @V_ITMAPURPREC_VRFATOCONV   DOUBLE PRECISION;
DECLARE @V_ITMAPURPREC_VRARREDCMP   DOUBLE PRECISION;
DECLARE @V_ITMAPURPREC_QTSOLACOMP   DOUBLE PRECISION;
DECLARE @V_ITMAPURPREC_IDUTQTDISPFORN VARCHAR(1);

DECLARE @V_NRPEDIDOCOL              VARCHAR(10);
DECLARE @V_QTSOLACOMP               DOUBLE PRECISION; /*Qtde. em produto de compra*/
DECLARE @V_QTRESTANTE               DOUBLE PRECISION; /*Qtde. em produto de estoque*/
DECLARE @V_QTDEDISPONIVEL           DOUBLE PRECISION; /*Qtde. em produto de compra*/
DECLARE @V_STRINGISPONIVEL          VARCHAR(50);

DECLARE @V_IDCONSPRSOL VARCHAR(1);
DECLARE @V_IDUTILCONSSOLIOL VARCHAR(1);
DECLARE @V_IDUTQTDISPGERAL  VARCHAR(1);
DECLARE @V_IDCONSOLAPUEFET  VARCHAR(1);
DECLARE @V_CDFORNOPELOG     VARCHAR(20);
DECLARE @V_IDUTLMARPREFOL   VARCHAR(1);
DECLARE @V_IDUTLPRARVOLCMP    VARCHAR(1);
DECLARE @V_IDCONSARREDCMPAPUR VARCHAR(1);
DECLARE @V_VRARREDEMPE        DOUBLE PRECISION;

DECLARE @V_LISTA VARCHAR(20); /* NUMERO DA PRXLISTA */

BEGIN
  UPDATE ITMAPURPREC
  SET IDITMSELAPUR = 'N', /* Desmarcando as apuraes j feitas - APURA_MELHOR_COTACAO */
      IDMOTIVPRESC = '0000000000',
      QTACOMP      = QTSOLACOMP
  WHERE
    ITMAPURPREC.CDCENTITMAP = @P_CDCENTCMP AND
    ITMAPURPREC.NRSEQITMAP  = @P_NRSEQAPUR;

  SELECT
     @V_IDCONSOLAPUEFET = MAX(IDCONSOLAPUEFET)
  FROM APURPRECO
  WHERE CDFILCENTCMP = @P_CDCENTCMP
    AND NRAPURPREC = @P_NRSEQAPUR;

  SELECT /* 3 APURA_MELHOR_COTACAO */
    @V_IDTIPOAPUR         = MAX(IDTIPOAPUR),
    @V_IDUTILCONSSOLIOL   = ISNULL(MAX(IDUTILCONSSOLIOL), 'N'),
    @V_IDCONSPRSOL        = ISNULL(MAX(IDCONSPRSOL), 'N'),
    @V_IDUTQTDISPGERAL    = ISNULL(MAX(IDUTQTDISPGERAL), 'N'),
    @V_IDUTLMARPREFOL     = ISNULL(MAX(IDUTLMARPREFOL), 'N'),
    @V_IDUTLPRARVOLCMP    = ISNULL(MAX(IDUTLPRARVOLCMP), 'N'),
    @V_IDCONSARREDCMPAPUR = ISNULL(MAX(IDCONSARREDCMPAPUR), 'N')
  FROM
    PARASUPRI
  WHERE
    CDFILIAL = @P_CDCENTCMP;

  IF ISNULL(@V_IDCONSPRSOL, 'N') = 'N' BEGIN
     EXEC NOVO_CODIGO 'LISTA', @P_SEQUENCIAL = @V_LISTA OUTPUT, @P_QTDE = 1;
     SET @V_LISTA = SUBSTRING(@V_LISTA,11,10);
     DECLARE C_REGIAO CURSOR FOR
       (SELECT /* Agrupa por regio - APURA_MELHOR_COTACAO */
          DISTINCT
          ITMAPURPREC.CDREGITMAP,
          PRODUTO.CDPRODESTO,
          ITMAPURPREC.CDFILIAP,
          ITMAPURPREC.DTENTRAPUT,
          ISNULL(FILIAL.IDFUNCAOFILI, 'Z') IDFUNCAOFILI,
          ENDEFILI.CDPAIS,
          ENDEFILI.SGESTADO,
          ENDEFILI.CDMUNICIPIO
        FROM
          PRODUTO,
          FILIAL,
          ENDEFILI,
          ITMAPURPREC
        WHERE
          ITMAPURPREC.CDFILIAP    = FILIAL.CDFILIAL AND
          ITMAPURPREC.CDCENTITMAP = @P_CDCENTCMP    AND
          ITMAPURPREC.NRSEQITMAP  = @P_NRSEQAPUR    AND
          ENDEFILI.CDFILIAL       = FILIAL.CDFILIAL AND
          ENDEFILI.IDTPENDEFILI   = 'P'             AND
          ITMAPURPREC.CDPRODITMAP = PRODUTO.CDPRODUTO)
     OPEN C_REGIAO;
     FETCH NEXT FROM C_REGIAO INTO @V_REGIAO_CDREGITMAP,
                                   @V_REGIAO_CDPRODESTO,
                                   @V_REGIAO_CDFILIAP,
                                   @V_REGIAO_DTENTRAPUT,
                                   @V_REGIAO_IDFUNCAOFILI,
                                   @V_REGIAO_CDPAIS,
                                   @V_REGIAO_SGESTADO,
                                   @V_REGIAO_CDMUNICIPIO;
     WHILE (@@FETCH_STATUS = 0) BEGIN
       SET @V_QTSOLACOMP = 0;
       IF @V_IDUTILCONSSOLIOL = 'N' BEGIN
          SELECT @V_CDFORNOPELOG = MAX(F.CDFORNOPELOG)
            FROM PARAMPRODSUP P, FILIAL F
           WHERE P.CDFILIAL     = @V_REGIAO_CDFILIAP
             AND P.CDFILIOPELOG = F.CDFILIAL
             AND P.CDFILIOPELOG IS NOT NULL;
       END;
       IF ((@V_REGIAO_IDFUNCAOFILI <> 'O') OR (@V_IDUTILCONSSOLIOL = 'N')) BEGIN
          DECLARE C_ITMAPURPREC CURSOR FOR /* O primeiro registro tem o melhor preo  - APURA_MELHOR_COTACAO */
             SELECT
                ITMAPURPREC.CDCENTITMAP,
                ITMAPURPREC.NRSEQITMAP,
                ITMAPURPREC.CDREGITMAP,
                ITMAPURPREC.CDFORNITMAP,
                ITMAPURPREC.NRCOLEITMAP,
                ITMAPURPREC.DTENTRAPUT,
                ITMAPURPREC.CDFILIAP,
                ITMAPURPREC.CDPRODITMAP,
                ITMAPURPREC.CDMARCITMAP,
                PRODUTO.VRFATOCONV,
                PRODUTO.VRARREDCMP,
                ITMAPURPREC.QTSOLACOMP,
                CASE LEN(PRODPREFMED.CDPRODPREF)
                     WHEN 10 THEN '1'
                     ELSE '0'
                END +
                CASE LEN(PPMF.CDTIPPART)
                     WHEN 1 THEN PPMF.CDTIPPART
                     ELSE '0'
                END +
                CASE LEN(PPF.CDTIPPART)
                     WHEN 1 THEN PPF.CDTIPPART
                     ELSE '0'
                END +
                CASE LEN(PPM.CDTIPPART)
                     WHEN 1 THEN PPM.CDTIPPART
                     ELSE '0'
                END +
                CASE ITEMCOLE.IDITMLISPREC
                    WHEN 'S' THEN '1'
                    ELSE '2'
                END +
                CASE @V_IDCONSOLAPUEFET
                   WHEN 'X' THEN '0'
                   WHEN 'S' THEN ISNULL(CASE LEN(FORNECMPEXTRA.CDFORNECED)
                                           WHEN 0 THEN '1'
                                           ELSE '2'
                                        END, '1')
                   ELSE '3'
                END +
                '0000' AS IDMOTIVPRESC,
                FORNECEDOR.IDUTQTDISPFORN
              FROM
                ITMAPURPREC LEFT JOIN PRODPREFMED ON
                               ITMAPURPREC.CDFILIAP     = PRODPREFMED.CDFILIAL   AND
                               @V_REGIAO_CDPRODESTO     = PRODPREFMED.CDPRODUTO  AND
                               ITMAPURPREC.CDPRODITMAP  = PRODPREFMED.CDPRODPREF
                            LEFT JOIN PARTFILI PPM ON
                               ITMAPURPREC.CDFILIAP     = PPM.CDFILIAL    AND
                               ITMAPURPREC.CDPRODITMAP  = PPM.CDPRODUTO   AND
                               ITMAPURPREC.CDMARCITMAP  = PPM.CDMARCA
                            LEFT JOIN PARTFILI PPF ON
                               ITMAPURPREC.CDFILIAP     = PPF.CDFILIAL    AND
                               ITMAPURPREC.CDPRODITMAP  = PPF.CDPRODUTO   AND
                               ITMAPURPREC.CDFORNITMAP  = PPF.CDFORNECED  AND
                               ITMAPURPREC.NRCOLEITMAP  = ISNULL(PPF.NRCOLEPRECO, ITMAPURPREC.NRCOLEITMAP)
                            LEFT JOIN PARTFILI PPMF ON
                               ITMAPURPREC.CDFILIAP     = PPMF.CDFILIAL   AND
                               ITMAPURPREC.CDPRODITMAP  = PPMF.CDPRODUTO  AND
                               ITMAPURPREC.CDMARCITMAP  = PPMF.CDMARCA    AND
                               ITMAPURPREC.CDFORNITMAP  = PPMF.CDFORNECED
                            LEFT JOIN ITEMCOLE ON
                               ITMAPURPREC.CDCENTITMAP  = ITEMCOLE.CDFILIAL      AND
                               ITMAPURPREC.NRCOLEITMAP  = ITEMCOLE.NRCOLEPRECO   AND
                               ITMAPURPREC.CDMARCITMAP  = ITEMCOLE.CDMARCA       AND
                               ITMAPURPREC.CDREGITMAP   = ITEMCOLE.CDREGIAO      AND
                               ITMAPURPREC.CDFORNITMAP  = ITEMCOLE.CDFORNECED    AND
                               ITMAPURPREC.CDPRODITMAP  = ITEMCOLE.CDPRODUTO,
                PRODUTO,
                FORNECEDOR LEFT JOIN FORNECMPEXTRA
                                  ON FORNECEDOR.CDFORNECED = FORNECMPEXTRA.CDFORNECED  AND
                                     @V_REGIAO_CDPAIS      = FORNECMPEXTRA.CDPAIS      AND
                                     @V_REGIAO_SGESTADO    = FORNECMPEXTRA.SGESTADO    AND
                                     @V_REGIAO_CDMUNICIPIO = FORNECMPEXTRA.CDMUNICIPIO
              WHERE
                ITMAPURPREC.CDCENTITMAP  = @P_CDCENTCMP              AND
                ITMAPURPREC.NRSEQITMAP   = @P_NRSEQAPUR              AND
                ITMAPURPREC.CDREGITMAP   = @V_REGIAO_CDREGITMAP      AND
                ITMAPURPREC.DTENTRAPUT   = @V_REGIAO_DTENTRAPUT      AND
                ITMAPURPREC.CDFILIAP     = @V_REGIAO_CDFILIAP        AND
                ITMAPURPREC.CDPRODITMAP  = PRODUTO.CDPRODUTO         AND
                PRODUTO.CDPRODESTO       = @V_REGIAO_CDPRODESTO      AND
                ITMAPURPREC.CDFORNITMAP  = FORNECEDOR.CDFORNECED
              ORDER BY
                /* Estabelecendo prioridades - O primeiro registro retornado ser o escolhido */
                CASE @V_IDCONSOLAPUEFET   /* QUANDO A SOLICITAO FOR EXTRA, DESCONSIDERA O FORNECEDOR LOGISTICO (OL COM AF)*/
                     WHEN 'S' THEN CASE ITMAPURPREC.CDFORNITMAP
                                       WHEN @V_CDFORNOPELOG THEN -10
                                       ELSE -11
                                   END
                     ELSE 0
                END,

                CASE ISNULL(PRODPREFMED.CDPRODPREF, 'X')
                    WHEN 'X' THEN -1
                    ELSE -10
                END,

                CASE PPMF.CDTIPPART
                    WHEN '7' THEN -9
                    WHEN '8' THEN -8
                    WHEN '9' THEN 1
                    ELSE 0
                END,

                CASE PPF.CDTIPPART
                    WHEN '4' THEN -9
                    WHEN '5' THEN -8
                    WHEN '6' THEN 1
                    ELSE  0
                END,

                CASE PPF.NRCOLEPRECO
                    WHEN ITMAPURPREC.NRCOLEITMAP THEN -9
                    ELSE 0
                END,

                CASE PPM.CDTIPPART
                    WHEN '1' THEN -9
                    WHEN '2' THEN -8
                    WHEN '3' THEN 1
                    ELSE 0
                END,

                CASE @V_IDCONSOLAPUEFET
                   WHEN 'S' THEN CASE FORNECMPEXTRA.CDFORNECED
                                    WHEN ITMAPURPREC.CDFORNITMAP THEN -9
                                    ELSE 0
                                 END
                   ELSE 0
                END,

                CASE PPF.CDTIPPART+PPF.NRCOLEPRECO
                   WHEN '4'+ITMAPURPREC.NRCOLEITMAP THEN QTACOMP * (CASE @V_IDTIPOAPUR
                                                                       WHEN '1' THEN VRPRECECOAP
                                                                       WHEN '2' THEN VRPRECONPIAP
                                                                       ELSE VRPRECUNIAP
                                                                    END)
                   ELSE
                     CASE @V_IDCONSOLAPUEFET
                        WHEN 'S' THEN CASE FORNECMPEXTRA.CDFORNECED
                                         WHEN ITMAPURPREC.CDFORNITMAP THEN QTACOMP * (CASE @V_IDTIPOAPUR
                                                                                         WHEN '1' THEN VRPRECECOAP
                                                                                         WHEN '2' THEN VRPRECONPIAP
                                                                                         ELSE VRPRECUNIAP
                                                                                      END)
                                         ELSE CASE ITMAPURPREC.IDITMLISPRAP
                                                 WHEN 'S' THEN -6
                                                 ELSE -5
                                              END
                                      END
                        ELSE CASE ITMAPURPREC.IDITMLISPRAP
                                WHEN 'S' THEN -6
                                ELSE -5
                             END
                     END
                END,

                QTACOMP * (CASE @V_IDTIPOAPUR
                              WHEN '1' THEN VRPRECECOAP
                              WHEN '2' THEN VRPRECONPIAP
                              ELSE VRPRECUNIAP
                           END
                           ),

                ITMAPURPREC.CDMARCITMAP

          OPEN C_ITMAPURPREC;
          FETCH NEXT FROM C_ITMAPURPREC INTO @V_ITMAPURPREC_CDCENTITMAP,
                                             @V_ITMAPURPREC_NRSEQITMAP,
                                             @V_ITMAPURPREC_CDREGITMAP,
                                             @V_ITMAPURPREC_CDFORNITMAP,
                                             @V_ITMAPURPREC_NRCOLEITMAP,
                                             @V_ITMAPURPREC_DTENTRAPUT,
                                             @V_ITMAPURPREC_CDFILIAP,
                                             @V_ITMAPURPREC_CDPRODITMAP,
                                             @V_ITMAPURPREC_CDMARCITMAP,
                                             @V_ITMAPURPREC_VRFATOCONV,
                                             @V_ITMAPURPREC_VRARREDCMP,
                                             @V_ITMAPURPREC_QTSOLACOMP,
                                             @V_ITMAPURPREC_IDMOTIVPRESC,
                                             @V_ITMAPURPREC_IDUTQTDISPFORN;

          WHILE (@@FETCH_STATUS = 0) BEGIN
             IF (@V_IDUTQTDISPGERAL = 'S' AND @V_ITMAPURPREC_IDUTQTDISPFORN = 'S') BEGIN
                IF @V_QTSOLACOMP = 0 BEGIN
                   SET @V_QTSOLACOMP = @V_ITMAPURPREC_QTSOLACOMP;
                   SET @V_QTRESTANTE = @V_ITMAPURPREC_QTSOLACOMP;
                END
                ELSE BEGIN
                   IF @V_QTRESTANTE > 0 BEGIN
                      SET @V_QTSOLACOMP = (@V_QTRESTANTE/@V_ITMAPURPREC_VRFATOCONV);
                      IF (((CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_ITMAPURPREC_VRARREDCMP)  - (ROUND(@V_QTSOLACOMP / @V_ITMAPURPREC_VRARREDCMP, 0, 1))) <> 0) AND @V_ITMAPURPREC_VRARREDCMP > 0
                      BEGIN
                         SET @V_QTSOLACOMP = CEILING(CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_ITMAPURPREC_VRARREDCMP) * @V_ITMAPURPREC_VRARREDCMP;
                      END;
                     IF @V_IDCONSARREDCMPAPUR = 'S' BEGIN
                        SELECT @V_VRARREDEMPE = CASE ISNULL(MAX(VRARREDEMPE), 0)
                                                   WHEN 0
                                                   THEN 1
                                                   ELSE ISNULL(MAX(VRARREDEMPE), 0)
                                                END
                          FROM PRODFORNCOMP
                         WHERE CDFORNECED = @V_ITMAPURPREC_CDFORNITMAP
                           AND CDPRODUTO  = @V_ITMAPURPREC_CDPRODITMAP;
                        IF (((CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_VRARREDEMPE)  - (ROUND(@V_QTSOLACOMP / @V_VRARREDEMPE, 0, 1))) <> 0) AND @V_VRARREDEMPE > 0
                        BEGIN
                           SET @V_QTSOLACOMP = CEILING(CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_VRARREDEMPE) * @V_VRARREDEMPE;
                        END;
                     END;
                   END;
                END;

                SET @V_NRPEDIDOCOL = NULL;
                SELECT @V_NRPEDIDOCOL = MAX(NRPEDIDOCOL)
                FROM ITEMCOLE
                WHERE ITEMCOLE.CDFILIAL    = @V_ITMAPURPREC_CDCENTITMAP
                  AND ITEMCOLE.NRCOLEPRECO = @V_ITMAPURPREC_NRCOLEITMAP
                  AND ITEMCOLE.CDREGIAO    = @V_ITMAPURPREC_CDREGITMAP
                  AND ITEMCOLE.CDFORNECED  = @V_ITMAPURPREC_CDFORNITMAP
                  AND ITEMCOLE.CDPRODUTO   = @V_ITMAPURPREC_CDPRODITMAP
                  AND ITEMCOLE.CDMARCA     = @V_ITMAPURPREC_CDMARCITMAP;

                IF @V_NRPEDIDOCOL IS NOT NULL BEGIN
                   SET @V_QTDEDISPONIVEL  = NULL;
                   SET @V_STRINGISPONIVEL = NULL;
                   SELECT @V_STRINGISPONIVEL = SUBSTRING(MAX(CDLISTA), 30, LEN(MAX(CDLISTA)))
                   FROM LISTA
                   WHERE NRLISTA = @V_LISTA
                     AND SUBSTRING(CDLISTA, 1, 29) = @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                                     @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP;
                   IF @V_STRINGISPONIVEL IS NULL BEGIN
                      SELECT @V_QTDEDISPONIVEL = MAX(QTDISPPRODMARC)
                      FROM PRMARCPEDCOL
                      WHERE PRMARCPEDCOL.CDFILIAL    = @V_ITMAPURPREC_CDCENTITMAP
                        AND PRMARCPEDCOL.NRPEDIDOCOL = @V_NRPEDIDOCOL
                        AND PRMARCPEDCOL.CDPRODUTO   = @V_ITMAPURPREC_CDPRODITMAP
                        AND PRMARCPEDCOL.CDMARCA     = @V_ITMAPURPREC_CDMARCITMAP;
                      IF @V_QTDEDISPONIVEL IS NOT NULL BEGIN
                         UPDATE LISTA
                         SET NRLISTA = @V_LISTA,
                             CDLISTA = @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                       @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP+CONVERT(VARCHAR, @V_QTDEDISPONIVEL)
                         WHERE NRLISTA = @V_LISTA
                           AND CDLISTA LIKE @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+@V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP+'%';
                         IF (NOT @@ROWCOUNT > 0) BEGIN
                            INSERT INTO LISTA (NRLISTA, CDLISTA)
                            VALUES(@V_LISTA,
                                   @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                   @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP+CONVERT(VARCHAR, @V_QTDEDISPONIVEL))
                         END;
                      END;
                   END
                   ELSE BEGIN
                      SET @V_QTDEDISPONIVEL = CONVERT(DOUBLE PRECISION, @V_STRINGISPONIVEL);
                   END;

                   IF @V_QTDEDISPONIVEL IS NOT NULL BEGIN
                      IF @V_QTDEDISPONIVEL >= @V_QTSOLACOMP BEGIN
                         SET @V_QTRESTANTE = 0;
                         SET @V_QTDEDISPONIVEL = @V_QTDEDISPONIVEL - @V_QTSOLACOMP;
                         UPDATE LISTA
                         SET CDLISTA = SUBSTRING(CDLISTA, 1, 29) + CONVERT(VARCHAR, @V_QTDEDISPONIVEL)
                         WHERE NRLISTA = @V_LISTA
                           AND SUBSTRING(CDLISTA, 1, 29) = @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                                           @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP;
                      END
                      ELSE BEGIN
                         SET @V_QTRESTANTE = (@V_QTSOLACOMP - @V_QTDEDISPONIVEL)*(@V_ITMAPURPREC_VRFATOCONV);
                         SET @V_QTSOLACOMP = @V_QTDEDISPONIVEL;
                         SET @V_QTDEDISPONIVEL = @V_QTDEDISPONIVEL - @V_QTSOLACOMP;
                         UPDATE LISTA
                         SET CDLISTA = SUBSTRING(CDLISTA, 1, 29) + CONVERT(VARCHAR, 0)
                         WHERE NRLISTA = @V_LISTA
                           AND SUBSTRING(CDLISTA, 1, 29) = @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                                           @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP;
                         IF (((CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_ITMAPURPREC_VRARREDCMP)  - (ROUND(@V_QTSOLACOMP / @V_ITMAPURPREC_VRARREDCMP, 0, 1))) <> 0) AND @V_ITMAPURPREC_VRARREDCMP > 0
                         BEGIN
                            SET @V_QTSOLACOMP = CEILING(CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_ITMAPURPREC_VRARREDCMP) * @V_ITMAPURPREC_VRARREDCMP;
                         END;
                        IF @V_IDCONSARREDCMPAPUR = 'S' BEGIN
                           SELECT @V_VRARREDEMPE = CASE ISNULL(MAX(VRARREDEMPE), 0)
                                                      WHEN 0
                                                      THEN 1
                                                      ELSE ISNULL(MAX(VRARREDEMPE), 0)
                                                   END
                             FROM PRODFORNCOMP
                            WHERE CDFORNECED = @V_ITMAPURPREC_CDFORNITMAP
                              AND CDPRODUTO  = @V_ITMAPURPREC_CDPRODITMAP;
                           IF (((CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_VRARREDEMPE)  - (ROUND(@V_QTSOLACOMP / @V_VRARREDEMPE, 0, 1))) <> 0) AND @V_VRARREDEMPE > 0
                           BEGIN
                              SET @V_QTSOLACOMP = CEILING(CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_VRARREDEMPE) * @V_VRARREDEMPE;
                           END;
                        END;
                      END;
                   END
                   ELSE BEGIN
                      SET @V_QTRESTANTE = 0;
                   END;
                END
                ELSE BEGIN
                   SET @V_QTRESTANTE = 0;
                END;
                IF @V_QTSOLACOMP > 0 BEGIN
                   UPDATE ITMAPURPREC /* Escolhendo primeiro registro - APURA_MELHOR_COTACAO */
                   SET IDITMSELAPUR = 'S',
                       QTACOMP = @V_QTSOLACOMP,
                       IDMOTIVPRESC = @V_ITMAPURPREC_IDMOTIVPRESC
                   WHERE
                      CDCENTITMAP = @V_ITMAPURPREC_CDCENTITMAP AND
                      NRSEQITMAP  = @V_ITMAPURPREC_NRSEQITMAP  AND
                      CDREGITMAP  = @V_ITMAPURPREC_CDREGITMAP  AND
                      CDFORNITMAP = @V_ITMAPURPREC_CDFORNITMAP AND
                      NRCOLEITMAP = @V_ITMAPURPREC_NRCOLEITMAP AND
                      DTENTRAPUT  = @V_ITMAPURPREC_DTENTRAPUT  AND
                      CDFILIAP    = @V_ITMAPURPREC_CDFILIAP    AND
                      CDPRODITMAP = @V_ITMAPURPREC_CDPRODITMAP AND
                      CDMARCITMAP = @V_ITMAPURPREC_CDMARCITMAP;
                END;
             END
             ELSE BEGIN
                UPDATE ITMAPURPREC /* Escolhendo primeiro registro - APURA_MELHOR_COTACAO */
                SET IDITMSELAPUR = 'S',
                    QTACOMP      = QTSOLACOMP,
                    IDMOTIVPRESC = @V_ITMAPURPREC_IDMOTIVPRESC
                WHERE
                   CDCENTITMAP = @V_ITMAPURPREC_CDCENTITMAP AND
                   NRSEQITMAP  = @V_ITMAPURPREC_NRSEQITMAP  AND
                   CDREGITMAP  = @V_ITMAPURPREC_CDREGITMAP  AND
                   CDFORNITMAP = @V_ITMAPURPREC_CDFORNITMAP AND
                   NRCOLEITMAP = @V_ITMAPURPREC_NRCOLEITMAP AND
                   DTENTRAPUT  = @V_ITMAPURPREC_DTENTRAPUT  AND
                   CDFILIAP    = @V_ITMAPURPREC_CDFILIAP    AND
                   CDPRODITMAP = @V_ITMAPURPREC_CDPRODITMAP AND
                   CDMARCITMAP = @V_ITMAPURPREC_CDMARCITMAP;
             END;

             FETCH NEXT FROM C_ITMAPURPREC INTO @V_ITMAPURPREC_CDCENTITMAP,
                                                @V_ITMAPURPREC_NRSEQITMAP,
                                                @V_ITMAPURPREC_CDREGITMAP,
                                                @V_ITMAPURPREC_CDFORNITMAP,
                                                @V_ITMAPURPREC_NRCOLEITMAP,
                                                @V_ITMAPURPREC_DTENTRAPUT,
                                                @V_ITMAPURPREC_CDFILIAP,
                                                @V_ITMAPURPREC_CDPRODITMAP,
                                                @V_ITMAPURPREC_CDMARCITMAP,
                                                @V_ITMAPURPREC_VRFATOCONV,
                                                @V_ITMAPURPREC_VRARREDCMP,
                                                @V_ITMAPURPREC_QTSOLACOMP,
                                                @V_ITMAPURPREC_IDMOTIVPRESC,
                                                @V_ITMAPURPREC_IDUTQTDISPFORN;

            IF (@V_IDUTQTDISPGERAL = 'S' AND @V_ITMAPURPREC_IDUTQTDISPFORN = 'S') BEGIN
               IF @V_QTRESTANTE = 0 BEGIN
                  BREAK; /* Sai do Loop */
               END;
            END
            ELSE BEGIN
               BREAK; /* Sai do Loop */
            END;
          END;
          CLOSE C_ITMAPURPREC;
          DEALLOCATE C_ITMAPURPREC;
       END;

       FETCH NEXT FROM C_REGIAO INTO @V_REGIAO_CDREGITMAP,
                                     @V_REGIAO_CDPRODESTO,
                                     @V_REGIAO_CDFILIAP,
                                     @V_REGIAO_DTENTRAPUT,
                                     @V_REGIAO_IDFUNCAOFILI,
                                     @V_REGIAO_CDPAIS,
                                     @V_REGIAO_SGESTADO,
                                     @V_REGIAO_CDMUNICIPIO;
     END;
     CLOSE C_REGIAO;
     DEALLOCATE C_REGIAO;
     DELETE FROM LISTA
     WHERE NRLISTA = @V_LISTA;
  END
  ELSE BEGIN
     EXEC NOVO_CODIGO 'LISTA', @P_SEQUENCIAL = @V_LISTA OUTPUT, @P_QTDE = 1;
     SET @V_LISTA = SUBSTRING(@V_LISTA,11,10);
     DECLARE C_REGIAO CURSOR FOR
       (SELECT /* Agrupa por regio - APURA_MELHOR_COTACAO */
          DISTINCT
          ITMAPURPREC.CDREGITMAP,
          ITMAPURPREC.CDPRODITMAP,
          PRODUTO.CDPRODESTO,
          ITMAPURPREC.CDFILIAP,
          ITMAPURPREC.DTENTRAPUT,
          ISNULL(FILIAL.IDFUNCAOFILI, 'Z') IDFUNCAOFILI,
          ENDEFILI.CDPAIS,
          ENDEFILI.SGESTADO,
          ENDEFILI.CDMUNICIPIO
        FROM
          ITMAPURPREC,
          FILIAL,
          ENDEFILI,
          PRODUTO
        WHERE
          ITMAPURPREC.CDFILIAP    = FILIAL.CDFILIAL   AND
          ITMAPURPREC.CDPRODITMAP = PRODUTO.CDPRODUTO AND
          ENDEFILI.CDFILIAL       = FILIAL.CDFILIAL   AND
          ENDEFILI.IDTPENDEFILI   = 'P'               AND
          ITMAPURPREC.CDCENTITMAP = @P_CDCENTCMP      AND
          ITMAPURPREC.NRSEQITMAP  = @P_NRSEQAPUR)
     OPEN C_REGIAO;
     FETCH NEXT FROM C_REGIAO INTO @V_REGIAO_CDREGITMAP,
                                   @V_REGIAO_CDPRODITMAP,
                                   @V_REGIAO_CDPRODESTO,
                                   @V_REGIAO_CDFILIAP,
                                   @V_REGIAO_DTENTRAPUT,
                                   @V_REGIAO_IDFUNCAOFILI,
                                   @V_REGIAO_CDPAIS,
                                   @V_REGIAO_SGESTADO,
                                   @V_REGIAO_CDMUNICIPIO;
     WHILE (@@FETCH_STATUS = 0) BEGIN
       SET @V_QTSOLACOMP = 0;
       IF ((@V_REGIAO_IDFUNCAOFILI <> 'O') OR (@V_IDUTILCONSSOLIOL = 'N')) BEGIN
          IF @V_IDUTILCONSSOLIOL = 'N' BEGIN
             SELECT @V_CDFORNOPELOG = MAX(F.CDFORNOPELOG)
               FROM PARAMPRODSUP P, FILIAL F
              WHERE P.CDFILIAL     = @V_REGIAO_CDFILIAP
                AND P.CDFILIOPELOG = F.CDFILIAL
                AND P.CDFILIOPELOG IS NOT NULL;
          END;
          DECLARE C_ITMAPURPREC CURSOR FOR /* O primeiro registro tem o melhor preo  - APURA_MELHOR_COTACAO */
              SELECT
                ITMAPURPREC.CDCENTITMAP,
                ITMAPURPREC.NRSEQITMAP,
                ITMAPURPREC.CDREGITMAP,
                ITMAPURPREC.CDFORNITMAP,
                ITMAPURPREC.NRCOLEITMAP,
                ITMAPURPREC.DTENTRAPUT,
                ITMAPURPREC.CDFILIAP,
                ITMAPURPREC.CDPRODITMAP,
                ITMAPURPREC.CDMARCITMAP,
                PRODUTO.VRFATOCONV,
                PRODUTO.VRARREDCMP,
                ITMAPURPREC.QTSOLACOMP,
                CASE LEN(PRODPREFMED.CDPRODPREF)
                     WHEN 10 THEN '1'
                     ELSE '0'
                END +
                CASE LEN(PPMF.CDTIPPART)
                     WHEN 1 THEN PPMF.CDTIPPART
                     ELSE '0'
                END +
                CASE LEN(PPF.CDTIPPART)
                     WHEN 1 THEN PPF.CDTIPPART
                     ELSE '0'
                END +
                CASE LEN(PPM.CDTIPPART)
                     WHEN 1 THEN PPM.CDTIPPART
                     ELSE '0'
                END +
                CASE ITEMCOLE.IDITMLISPREC
                    WHEN 'S' THEN '1'
                    ELSE '2'
                END +
                CASE @V_IDCONSOLAPUEFET
                   WHEN 'X' THEN '0'
                   WHEN 'S' THEN ISNULL(CASE LEN(FORNECMPEXTRA.CDFORNECED)
                                           WHEN 0 THEN '1'
                                           ELSE '2'
                                        END, '1')
                   ELSE '3'
                END +
                '0000' AS IDMOTIVPRESC,
                FORNECEDOR.IDUTQTDISPFORN
              FROM
                ITMAPURPREC LEFT JOIN PRODPREFMED ON
                               ITMAPURPREC.CDFILIAP     = PRODPREFMED.CDFILIAL   AND
                               @V_REGIAO_CDPRODESTO     = PRODPREFMED.CDPRODUTO  AND
                               ITMAPURPREC.CDPRODITMAP  = PRODPREFMED.CDPRODPREF
                            LEFT JOIN PARTFILI PPM ON
                               ITMAPURPREC.CDFILIAP     = PPM.CDFILIAL    AND
                               ITMAPURPREC.CDPRODITMAP  = PPM.CDPRODUTO   AND
                               ITMAPURPREC.CDMARCITMAP  = PPM.CDMARCA
                            LEFT JOIN PARTFILI PPF ON
                               ITMAPURPREC.CDFILIAP     = PPF.CDFILIAL    AND
                               ITMAPURPREC.CDPRODITMAP  = PPF.CDPRODUTO   AND
                               ITMAPURPREC.CDFORNITMAP  = PPF.CDFORNECED  AND
                               ITMAPURPREC.NRCOLEITMAP  = ISNULL(PPF.NRCOLEPRECO, ITMAPURPREC.NRCOLEITMAP)
                            LEFT JOIN PARTFILI PPMF ON
                               ITMAPURPREC.CDFILIAP     = PPMF.CDFILIAL   AND
                               ITMAPURPREC.CDPRODITMAP  = PPMF.CDPRODUTO  AND
                               ITMAPURPREC.CDMARCITMAP  = PPMF.CDMARCA    AND
                               ITMAPURPREC.CDFORNITMAP  = PPMF.CDFORNECED
                            LEFT JOIN ITEMCOLE ON
                               ITMAPURPREC.CDCENTITMAP  = ITEMCOLE.CDFILIAL      AND
                               ITMAPURPREC.NRCOLEITMAP  = ITEMCOLE.NRCOLEPRECO   AND
                               ITMAPURPREC.CDMARCITMAP  = ITEMCOLE.CDMARCA       AND
                               ITMAPURPREC.CDREGITMAP   = ITEMCOLE.CDREGIAO      AND
                               ITMAPURPREC.CDFORNITMAP  = ITEMCOLE.CDFORNECED    AND
                               ITMAPURPREC.CDPRODITMAP  = ITEMCOLE.CDPRODUTO,
                PRODUTO,
                FORNECEDOR LEFT JOIN FORNECMPEXTRA
                                  ON FORNECEDOR.CDFORNECED = FORNECMPEXTRA.CDFORNECED  AND
                                     @V_REGIAO_CDPAIS      = FORNECMPEXTRA.CDPAIS      AND
                                     @V_REGIAO_SGESTADO    = FORNECMPEXTRA.SGESTADO    AND
                                     @V_REGIAO_CDMUNICIPIO = FORNECMPEXTRA.CDMUNICIPIO
              WHERE
                ITMAPURPREC.CDCENTITMAP  = @P_CDCENTCMP              AND
                ITMAPURPREC.NRSEQITMAP   = @P_NRSEQAPUR              AND
                ITMAPURPREC.CDREGITMAP   = @V_REGIAO_CDREGITMAP      AND
                ITMAPURPREC.DTENTRAPUT   = @V_REGIAO_DTENTRAPUT      AND
                ITMAPURPREC.CDFILIAP     = @V_REGIAO_CDFILIAP        AND
                ITMAPURPREC.CDPRODITMAP  = PRODUTO.CDPRODUTO         AND
                ITMAPURPREC.CDPRODITMAP  = @V_REGIAO_CDPRODITMAP     AND
                ITMAPURPREC.CDFORNITMAP  = FORNECEDOR.CDFORNECED

              ORDER BY
                /* Estabelecendo prioridades - O primeiro registro retornado ser o escolhido */
                CASE @V_IDCONSOLAPUEFET   /* QUANDO A SOLICITAO FOR EXTRA, DESCONSIDERA O FORNECEDOR LOGISTICO (OL COM AF)*/
                     WHEN 'S' THEN CASE ITMAPURPREC.CDFORNITMAP
                                       WHEN @V_CDFORNOPELOG THEN -10
                                       ELSE -11
                                   END
                     ELSE 0
                END,

                CASE ISNULL(PRODPREFMED.CDPRODPREF, 'X')
                    WHEN 'X' THEN -1
                    ELSE -10
                END,

                CASE PPMF.CDTIPPART
                    WHEN '7' THEN -9
                    WHEN '8' THEN -8
                    WHEN '9' THEN 1
                    ELSE 0
                END,

                CASE PPF.CDTIPPART
                    WHEN '4' THEN -9
                    WHEN '5' THEN -8
                    WHEN '6' THEN 1
                    ELSE  0
                END,

                CASE PPF.NRCOLEPRECO
                    WHEN ITMAPURPREC.NRCOLEITMAP THEN -9
                    ELSE 0
                END,

                CASE PPM.CDTIPPART
                    WHEN '1' THEN -9
                    WHEN '2' THEN -8
                    WHEN '3' THEN 1
                    ELSE 0
                END,

                CASE @V_IDCONSOLAPUEFET
                   WHEN 'S' THEN CASE FORNECMPEXTRA.CDFORNECED
                                    WHEN ITMAPURPREC.CDFORNITMAP THEN -9
                                    ELSE 0
                                 END
                   ELSE 0
                END,

                CASE PPF.CDTIPPART+PPF.NRCOLEPRECO
                   WHEN '4'+ITMAPURPREC.NRCOLEITMAP THEN QTACOMP * (CASE @V_IDTIPOAPUR
                                                                       WHEN '1' THEN VRPRECECOAP
                                                                       WHEN '2' THEN VRPRECONPIAP
                                                                       ELSE VRPRECUNIAP
                                                                    END)
                   ELSE
                     CASE @V_IDCONSOLAPUEFET
                        WHEN 'S' THEN CASE FORNECMPEXTRA.CDFORNECED
                                         WHEN ITMAPURPREC.CDFORNITMAP THEN QTACOMP * (CASE @V_IDTIPOAPUR
                                                                                         WHEN '1' THEN VRPRECECOAP
                                                                                         WHEN '2' THEN VRPRECONPIAP
                                                                                         ELSE VRPRECUNIAP
                                                                                      END)
                                         ELSE CASE ITMAPURPREC.IDITMLISPRAP
                                                 WHEN 'S' THEN -6
                                                 ELSE -5
                                              END
                                      END
                        ELSE CASE ITMAPURPREC.IDITMLISPRAP
                                WHEN 'S' THEN -6
                                ELSE -5
                             END
                     END
                END,

                QTACOMP * (CASE @V_IDTIPOAPUR
                              WHEN '1' THEN VRPRECECOAP
                              WHEN '2' THEN VRPRECONPIAP
                              ELSE VRPRECUNIAP
                           END
                           ),

                ITMAPURPREC.CDMARCITMAP
            OPEN C_ITMAPURPREC;
            FETCH NEXT FROM C_ITMAPURPREC INTO @V_ITMAPURPREC_CDCENTITMAP,
                                               @V_ITMAPURPREC_NRSEQITMAP,
                                               @V_ITMAPURPREC_CDREGITMAP,
                                               @V_ITMAPURPREC_CDFORNITMAP,
                                               @V_ITMAPURPREC_NRCOLEITMAP,
                                               @V_ITMAPURPREC_DTENTRAPUT,
                                               @V_ITMAPURPREC_CDFILIAP,
                                               @V_ITMAPURPREC_CDPRODITMAP,
                                               @V_ITMAPURPREC_CDMARCITMAP,
                                               @V_ITMAPURPREC_VRFATOCONV,
                                               @V_ITMAPURPREC_VRARREDCMP,
                                               @V_ITMAPURPREC_QTSOLACOMP,
                                               @V_ITMAPURPREC_IDMOTIVPRESC,
                                               @V_ITMAPURPREC_IDUTQTDISPFORN;
           WHILE (@@FETCH_STATUS = 0) BEGIN
              IF (@V_IDUTQTDISPGERAL = 'S' AND @V_ITMAPURPREC_IDUTQTDISPFORN = 'S') BEGIN
                 IF @V_QTSOLACOMP = 0 BEGIN
                    SET @V_QTSOLACOMP = @V_ITMAPURPREC_QTSOLACOMP;
                    SET @V_QTRESTANTE = @V_ITMAPURPREC_QTSOLACOMP;
                 END
                 ELSE BEGIN
                    IF @V_QTRESTANTE > 0 BEGIN
                       SET @V_QTSOLACOMP = (@V_QTRESTANTE/@V_ITMAPURPREC_VRFATOCONV);
                       IF (((CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_ITMAPURPREC_VRARREDCMP)  - (ROUND(@V_QTSOLACOMP / @V_ITMAPURPREC_VRARREDCMP, 0, 1))) <> 0) AND @V_ITMAPURPREC_VRARREDCMP > 0
                       BEGIN
                          SET @V_QTSOLACOMP = CEILING(CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_ITMAPURPREC_VRARREDCMP) * @V_ITMAPURPREC_VRARREDCMP;
                       END;
                        IF @V_IDCONSARREDCMPAPUR = 'S' BEGIN
                           SELECT @V_VRARREDEMPE = CASE ISNULL(MAX(VRARREDEMPE), 0)
                                                      WHEN 0
                                                      THEN 1
                                                      ELSE ISNULL(MAX(VRARREDEMPE), 0)
                                                   END
                             FROM PRODFORNCOMP
                            WHERE CDFORNECED = @V_ITMAPURPREC_CDFORNITMAP
                              AND CDPRODUTO  = @V_ITMAPURPREC_CDPRODITMAP;
                           IF (((CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_VRARREDEMPE)  - (ROUND(@V_QTSOLACOMP / @V_VRARREDEMPE, 0, 1))) <> 0) AND @V_VRARREDEMPE > 0
                           BEGIN
                              SET @V_QTSOLACOMP = CEILING(CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_VRARREDEMPE) * @V_VRARREDEMPE;
                           END;
                        END;
                    END;
                 END;

                 IF @V_NRPEDIDOCOL IS NOT NULL BEGIN
                    SET @V_QTDEDISPONIVEL  = NULL;
                    SET @V_STRINGISPONIVEL = NULL;
                    SELECT @V_STRINGISPONIVEL = SUBSTRING(MAX(CDLISTA), 30, LEN(MAX(CDLISTA)))
                    FROM LISTA
                    WHERE NRLISTA = @V_LISTA
                      AND SUBSTRING(CDLISTA, 1, 29) = @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                                      @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP;
                    IF @V_STRINGISPONIVEL IS NULL BEGIN
                       SELECT @V_QTDEDISPONIVEL = MAX(QTDISPPRODMARC)
                       FROM PRMARCPEDCOL
                       WHERE PRMARCPEDCOL.CDFILIAL    = @V_ITMAPURPREC_CDCENTITMAP
                         AND PRMARCPEDCOL.NRPEDIDOCOL = @V_NRPEDIDOCOL
                         AND PRMARCPEDCOL.CDPRODUTO   = @V_ITMAPURPREC_CDPRODITMAP
                         AND PRMARCPEDCOL.CDMARCA     = @V_ITMAPURPREC_CDMARCITMAP;
                       IF @V_QTDEDISPONIVEL IS NOT NULL BEGIN
                         UPDATE LISTA
                         SET NRLISTA = @V_LISTA,
                             CDLISTA = @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                       @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP+CONVERT(VARCHAR, @V_QTDEDISPONIVEL)
                         WHERE NRLISTA = @V_LISTA
                           AND CDLISTA LIKE @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+@V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP+'%';
                         IF (NOT @@ROWCOUNT > 0) BEGIN
                            INSERT INTO LISTA (NRLISTA, CDLISTA)
                            VALUES(@V_LISTA,
                                   @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                   @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP+CONVERT(VARCHAR, @V_QTDEDISPONIVEL))
                         END;
                       END;
                    END
                    ELSE BEGIN
                       SET @V_QTDEDISPONIVEL = CONVERT(DOUBLE PRECISION, @V_STRINGISPONIVEL);
                    END;

                    IF @V_QTDEDISPONIVEL IS NOT NULL BEGIN
                       IF @V_QTDEDISPONIVEL >= @V_QTSOLACOMP BEGIN
                          SET @V_QTRESTANTE = 0;
                          SET @V_QTDEDISPONIVEL = @V_QTDEDISPONIVEL - @V_QTSOLACOMP;
                          UPDATE LISTA
                          SET CDLISTA = SUBSTRING(CDLISTA, 1, 29) + CONVERT(VARCHAR, @V_QTDEDISPONIVEL)
                          WHERE NRLISTA = @V_LISTA
                            AND SUBSTRING(CDLISTA, 1, 29) = @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                                            @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP;
                       END
                       ELSE BEGIN
                          SET @V_QTRESTANTE = (@V_QTSOLACOMP - @V_QTDEDISPONIVEL)*(@V_ITMAPURPREC_VRFATOCONV);
                          SET @V_QTSOLACOMP = @V_QTDEDISPONIVEL;
                          SET @V_QTDEDISPONIVEL = @V_QTDEDISPONIVEL - @V_QTSOLACOMP;
                          UPDATE LISTA
                          SET CDLISTA = SUBSTRING(CDLISTA, 1, 29) + CONVERT(VARCHAR, 0)
                          WHERE NRLISTA = @V_LISTA
                            AND SUBSTRING(CDLISTA, 1, 29) = @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                                            @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP;
                          IF (((CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_ITMAPURPREC_VRARREDCMP)  - (ROUND(@V_QTSOLACOMP / @V_ITMAPURPREC_VRARREDCMP, 0, 1))) <> 0) AND @V_ITMAPURPREC_VRARREDCMP > 0
                          BEGIN
                             SET @V_QTSOLACOMP = CEILING(CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_ITMAPURPREC_VRARREDCMP) * @V_ITMAPURPREC_VRARREDCMP;
                          END;
                           IF @V_IDCONSARREDCMPAPUR = 'S' BEGIN
                              SELECT @V_VRARREDEMPE = CASE ISNULL(MAX(VRARREDEMPE), 0)
                                                         WHEN 0
                                                         THEN 1
                                                         ELSE ISNULL(MAX(VRARREDEMPE), 0)
                                                      END
                                FROM PRODFORNCOMP
                               WHERE CDFORNECED = @V_ITMAPURPREC_CDFORNITMAP
                                 AND CDPRODUTO  = @V_ITMAPURPREC_CDPRODITMAP;
                              IF (((CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_VRARREDEMPE)  - (ROUND(@V_QTSOLACOMP / @V_VRARREDEMPE, 0, 1))) <> 0) AND @V_VRARREDEMPE > 0
                              BEGIN
                                 SET @V_QTSOLACOMP = CEILING(CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_VRARREDEMPE) * @V_VRARREDEMPE;
                              END;
                           END;
                       END;
                    END
                    ELSE BEGIN
                       SET @V_QTRESTANTE = 0;
                    END;
                 END
                 ELSE BEGIN
                    SET @V_QTRESTANTE = 0;
                 END;
                 IF @V_QTSOLACOMP > 0 BEGIN
                    UPDATE ITMAPURPREC /* Escolhendo primeiro registro - APURA_MELHOR_COTACAO */
                    SET IDITMSELAPUR = 'S',
                        QTACOMP = @V_QTSOLACOMP,
                        IDMOTIVPRESC = @V_ITMAPURPREC_IDMOTIVPRESC
                    WHERE
                       CDCENTITMAP = @V_ITMAPURPREC_CDCENTITMAP AND
                       NRSEQITMAP  = @V_ITMAPURPREC_NRSEQITMAP  AND
                       CDREGITMAP  = @V_ITMAPURPREC_CDREGITMAP  AND
                       CDFORNITMAP = @V_ITMAPURPREC_CDFORNITMAP AND
                       NRCOLEITMAP = @V_ITMAPURPREC_NRCOLEITMAP AND
                       DTENTRAPUT  = @V_ITMAPURPREC_DTENTRAPUT  AND
                       CDFILIAP    = @V_ITMAPURPREC_CDFILIAP    AND
                       CDPRODITMAP = @V_ITMAPURPREC_CDPRODITMAP AND
                       CDMARCITMAP = @V_ITMAPURPREC_CDMARCITMAP;
                 END;
              END
              ELSE BEGIN
                 UPDATE ITMAPURPREC /* Escolhendo primeiro registro - APURA_MELHOR_COTACAO */
                 SET IDITMSELAPUR = 'S',
                     QTACOMP      = QTSOLACOMP,
                     IDMOTIVPRESC = @V_ITMAPURPREC_IDMOTIVPRESC
                 WHERE
                    CDCENTITMAP = @V_ITMAPURPREC_CDCENTITMAP AND
                    NRSEQITMAP  = @V_ITMAPURPREC_NRSEQITMAP  AND
                    CDREGITMAP  = @V_ITMAPURPREC_CDREGITMAP  AND
                    CDFORNITMAP = @V_ITMAPURPREC_CDFORNITMAP AND
                    NRCOLEITMAP = @V_ITMAPURPREC_NRCOLEITMAP AND
                    DTENTRAPUT  = @V_ITMAPURPREC_DTENTRAPUT  AND
                    CDFILIAP    = @V_ITMAPURPREC_CDFILIAP    AND
                    CDPRODITMAP = @V_ITMAPURPREC_CDPRODITMAP AND
                    CDMARCITMAP = @V_ITMAPURPREC_CDMARCITMAP;
              END;

              FETCH NEXT FROM C_ITMAPURPREC INTO @V_ITMAPURPREC_CDCENTITMAP,
                                                 @V_ITMAPURPREC_NRSEQITMAP,
                                                 @V_ITMAPURPREC_CDREGITMAP,
                                                 @V_ITMAPURPREC_CDFORNITMAP,
                                                 @V_ITMAPURPREC_NRCOLEITMAP,
                                                 @V_ITMAPURPREC_DTENTRAPUT,
                                                 @V_ITMAPURPREC_CDFILIAP,
                                                 @V_ITMAPURPREC_CDPRODITMAP,
                                                 @V_ITMAPURPREC_CDMARCITMAP,
                                                 @V_ITMAPURPREC_VRFATOCONV,
                                                 @V_ITMAPURPREC_VRARREDCMP,
                                                 @V_ITMAPURPREC_QTSOLACOMP,
                                                 @V_ITMAPURPREC_IDMOTIVPRESC,
                                                 @V_ITMAPURPREC_IDUTQTDISPFORN;

              IF (@V_IDUTQTDISPGERAL = 'S' AND @V_ITMAPURPREC_IDUTQTDISPFORN = 'S') BEGIN
                IF @V_QTRESTANTE = 0 BEGIN
                   BREAK; /* Sai do Loop  */
                END;
              END
              ELSE BEGIN
                 BREAK; /* Sai do Loop  */
              END;
           END;
           CLOSE C_ITMAPURPREC;
           DEALLOCATE C_ITMAPURPREC;
       END;
       FETCH NEXT FROM C_REGIAO INTO @V_REGIAO_CDREGITMAP,
                                     @V_REGIAO_CDPRODITMAP,
                                     @V_REGIAO_CDPRODESTO,
                                     @V_REGIAO_CDFILIAP,
                                     @V_REGIAO_DTENTRAPUT,
                                     @V_REGIAO_IDFUNCAOFILI,
                                     @V_REGIAO_CDPAIS,
                                     @V_REGIAO_SGESTADO,
                                     @V_REGIAO_CDMUNICIPIO;
     END;
     CLOSE C_REGIAO;
     DEALLOCATE C_REGIAO;
     DELETE FROM LISTA
     WHERE NRLISTA = @V_LISTA;

  END;

  IF @V_IDUTILCONSSOLIOL = 'S' BEGIN
     EXEC NOVO_CODIGO 'LISTA', @P_SEQUENCIAL = @V_LISTA OUTPUT, @P_QTDE = 1;
     SET @V_LISTA = SUBSTRING(@V_LISTA,11,10);
     DECLARE C_REGIAO CURSOR FOR
       (SELECT /* Agrupa por regio - APURA_MELHOR_COTACAO */
          DISTINCT
          ITMAPURPREC.CDREGITMAP,
          ITMAPURPREC.CDPRODITMAP,
          PRODUTO.CDPRODESTO,
          ITMAPURPREC.CDFILIAP,
          ITMAPURPREC.DTENTRAPUT,
          ISNULL(FILIAL.IDFUNCAOFILI, 'Z'),
          ENDEFILI.CDPAIS,
          ENDEFILI.SGESTADO,
          ENDEFILI.CDMUNICIPIO
        FROM
          ITMAPURPREC,
          FILIAL,
          ENDEFILI,
          PRODUTO
        WHERE
          ITMAPURPREC.CDFILIAP    = FILIAL.CDFILIAL   AND
          FILIAL.IDFUNCAOFILI     = 'O'               AND
          ITMAPURPREC.CDPRODITMAP = PRODUTO.CDPRODUTO AND
          ITMAPURPREC.CDCENTITMAP = @P_CDCENTCMP      AND
          ENDEFILI.CDFILIAL       = FILIAL.CDFILIAL   AND
          ENDEFILI.IDTPENDEFILI   = 'P'               AND
          ITMAPURPREC.NRSEQITMAP  = @P_NRSEQAPUR)
     OPEN C_REGIAO;
     FETCH NEXT FROM C_REGIAO INTO @V_REGIAO_CDREGITMAP,
                                   @V_REGIAO_CDPRODITMAP,
                                   @V_REGIAO_CDPRODESTO,
                                   @V_REGIAO_CDFILIAP,
                                   @V_REGIAO_DTENTRAPUT,
                                   @V_REGIAO_IDFUNCAOFILI,
                                   @V_REGIAO_CDPAIS,
                                   @V_REGIAO_SGESTADO,
                                   @V_REGIAO_CDMUNICIPIO;
     WHILE (@@FETCH_STATUS = 0) BEGIN
        SET @V_QTSOLACOMP = 0;
        DECLARE C_ITMAPURPREC CURSOR FOR /* O primeiro registro tem o melhor preo  - APURA_MELHOR_COTACAO */
            SELECT
              ITMAPURPREC.CDCENTITMAP,
              ITMAPURPREC.NRSEQITMAP,
              ITMAPURPREC.CDREGITMAP,
              ITMAPURPREC.CDFORNITMAP,
              ITMAPURPREC.NRCOLEITMAP,
              ITMAPURPREC.DTENTRAPUT,
              ITMAPURPREC.CDFILIAP,
              ITMAPURPREC.CDPRODITMAP,
              ITMAPURPREC.CDMARCITMAP,
              PRODUTO.VRFATOCONV,
              PRODUTO.VRARREDCMP,
              ITMAPURPREC.QTSOLACOMP,
              CASE LEN(PRODPREFMED.CDPRODPREF)
                   WHEN 10 THEN '1'
                   ELSE '0'
              END +
              CASE LEN(PPMF.CDTIPPART)
                   WHEN 1 THEN PPMF.CDTIPPART
                   ELSE '0'
              END +
              CASE LEN(PPF.CDTIPPART)
                   WHEN 1 THEN PPF.CDTIPPART
                   ELSE '0'
              END +
              CASE LEN(PPM.CDTIPPART)
                   WHEN 1 THEN PPM.CDTIPPART
                   ELSE '0'
              END +
              CASE ITEMCOLE.IDITMLISPREC
                  WHEN 'S' THEN '1'
                  ELSE '2'
              END +
              CASE @V_IDCONSOLAPUEFET
                 WHEN 'X' THEN '0'
                 WHEN 'S' THEN ISNULL(CASE LEN(FORNECMPEXTRA.CDFORNECED)
                                         WHEN 0 THEN '1'
                                         ELSE '2'
                                      END, '1')
                 ELSE '3'
              END + '0000' AS IDMOTIVPRESC,
              FORNECEDOR.IDUTQTDISPFORN
            FROM
              ITMAPURPREC LEFT JOIN PRODPREFMED ON
                             ITMAPURPREC.CDFILIAP     = PRODPREFMED.CDFILIAL   AND
                             @V_REGIAO_CDPRODESTO     = PRODPREFMED.CDPRODUTO  AND
                             ITMAPURPREC.CDPRODITMAP  = PRODPREFMED.CDPRODPREF
                          LEFT JOIN PARTFILI PPM ON
                             ITMAPURPREC.CDFILIAP     = PPM.CDFILIAL    AND
                             ITMAPURPREC.CDPRODITMAP  = PPM.CDPRODUTO   AND
                             ITMAPURPREC.CDMARCITMAP  = PPM.CDMARCA
                          LEFT JOIN PARTFILI PPF ON
                             ITMAPURPREC.CDFILIAP     = PPF.CDFILIAL    AND
                             ITMAPURPREC.CDPRODITMAP  = PPF.CDPRODUTO   AND
                             ITMAPURPREC.CDFORNITMAP  = PPF.CDFORNECED  AND
                             ITMAPURPREC.NRCOLEITMAP  = ISNULL(PPF.NRCOLEPRECO, ITMAPURPREC.NRCOLEITMAP)
                          LEFT JOIN PARTFILI PPMF ON
                             ITMAPURPREC.CDFILIAP     = PPMF.CDFILIAL   AND
                             ITMAPURPREC.CDPRODITMAP  = PPMF.CDPRODUTO  AND
                             ITMAPURPREC.CDMARCITMAP  = PPMF.CDMARCA    AND
                             ITMAPURPREC.CDFORNITMAP  = PPMF.CDFORNECED
                          LEFT JOIN ITEMCOLE ON
                             ITMAPURPREC.CDCENTITMAP  = ITEMCOLE.CDFILIAL      AND
                             ITMAPURPREC.NRCOLEITMAP  = ITEMCOLE.NRCOLEPRECO   AND
                             ITMAPURPREC.CDMARCITMAP  = ITEMCOLE.CDMARCA       AND
                             ITMAPURPREC.CDREGITMAP   = ITEMCOLE.CDREGIAO      AND
                             ITMAPURPREC.CDFORNITMAP  = ITEMCOLE.CDFORNECED    AND
                             ITMAPURPREC.CDPRODITMAP  = ITEMCOLE.CDPRODUTO,
              PRODUTO,
              FORNECEDOR LEFT JOIN FORNECMPEXTRA
                                ON FORNECEDOR.CDFORNECED = FORNECMPEXTRA.CDFORNECED  AND
                                   @V_REGIAO_CDPAIS      = FORNECMPEXTRA.CDPAIS      AND
                                   @V_REGIAO_SGESTADO    = FORNECMPEXTRA.SGESTADO    AND
                                   @V_REGIAO_CDMUNICIPIO = FORNECMPEXTRA.CDMUNICIPIO
            WHERE
              ITMAPURPREC.CDCENTITMAP  = @P_CDCENTCMP              AND
              ITMAPURPREC.NRSEQITMAP   = @P_NRSEQAPUR              AND
              ITMAPURPREC.CDREGITMAP   = @V_REGIAO_CDREGITMAP      AND
              ITMAPURPREC.DTENTRAPUT   = @V_REGIAO_DTENTRAPUT      AND
              ITMAPURPREC.CDFILIAP     = @V_REGIAO_CDFILIAP        AND
              ITMAPURPREC.CDPRODITMAP  = PRODUTO.CDPRODUTO         AND
              ITMAPURPREC.CDPRODITMAP  = @V_REGIAO_CDPRODITMAP     AND
              ITMAPURPREC.CDFORNITMAP  = FORNECEDOR.CDFORNECED

            ORDER BY
              /* Estabelecendo prioridades - O primeiro registro retornado ser o escolhido */
              CASE ISNULL(PRODPREFMED.CDPRODPREF, 'X')
                    WHEN 'X' THEN -1
                    ELSE -10
              END,

              CASE PPMF.CDTIPPART
                  WHEN '7' THEN -9
                  WHEN '8' THEN -8
                  WHEN '9' THEN 1
                  ELSE 0
              END,

              CASE PPF.CDTIPPART
                  WHEN '4' THEN -9
                  WHEN '5' THEN -8
                  WHEN '6' THEN 1
                  ELSE  0
              END,

              CASE PPF.NRCOLEPRECO
                  WHEN ITMAPURPREC.NRCOLEITMAP THEN -9
                  ELSE 0
              END,

              CASE PPM.CDTIPPART
                  WHEN '1' THEN -9
                  WHEN '2' THEN -8
                  WHEN '3' THEN 1
                  ELSE 0
              END,

              CASE @V_IDCONSOLAPUEFET
                 WHEN 'S' THEN CASE FORNECMPEXTRA.CDFORNECED
                                  WHEN ITMAPURPREC.CDFORNITMAP THEN -9
                                  ELSE 0
                               END
                 ELSE 0
              END,

              CASE PPF.CDTIPPART+PPF.NRCOLEPRECO
                 WHEN '4'+ITMAPURPREC.NRCOLEITMAP THEN QTACOMP * (CASE @V_IDTIPOAPUR
                                                                     WHEN '1' THEN VRPRECECOAP
                                                                     WHEN '2' THEN VRPRECONPIAP
                                                                     ELSE VRPRECUNIAP
                                                                  END)
                 ELSE
                   CASE @V_IDCONSOLAPUEFET
                      WHEN 'S' THEN CASE FORNECMPEXTRA.CDFORNECED
                                       WHEN ITMAPURPREC.CDFORNITMAP THEN QTACOMP * (CASE @V_IDTIPOAPUR
                                                                                       WHEN '1' THEN VRPRECECOAP
                                                                                       WHEN '2' THEN VRPRECONPIAP
                                                                                       ELSE VRPRECUNIAP
                                                                                    END)
                                       ELSE CASE ITMAPURPREC.IDITMLISPRAP
                                               WHEN 'S' THEN -6
                                               ELSE -5
                                            END
                                    END
                      ELSE CASE ITMAPURPREC.IDITMLISPRAP
                              WHEN 'S' THEN -6
                              ELSE -5
                           END
                   END
              END,

              QTACOMP * (CASE @V_IDTIPOAPUR
                            WHEN '1' THEN VRPRECECOAP
                            WHEN '2' THEN VRPRECONPIAP
                            ELSE VRPRECUNIAP
                         END
                         ),

              ITMAPURPREC.CDMARCITMAP
          OPEN C_ITMAPURPREC;
          FETCH NEXT FROM C_ITMAPURPREC INTO @V_ITMAPURPREC_CDCENTITMAP,
                                             @V_ITMAPURPREC_NRSEQITMAP,
                                             @V_ITMAPURPREC_CDREGITMAP,
                                             @V_ITMAPURPREC_CDFORNITMAP,
                                             @V_ITMAPURPREC_NRCOLEITMAP,
                                             @V_ITMAPURPREC_DTENTRAPUT,
                                             @V_ITMAPURPREC_CDFILIAP,
                                             @V_ITMAPURPREC_CDPRODITMAP,
                                             @V_ITMAPURPREC_CDMARCITMAP,
                                             @V_ITMAPURPREC_VRFATOCONV,
                                             @V_ITMAPURPREC_VRARREDCMP,
                                             @V_ITMAPURPREC_QTSOLACOMP,
                                             @V_ITMAPURPREC_IDMOTIVPRESC,
                                             @V_ITMAPURPREC_IDUTQTDISPFORN;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            IF (@V_IDUTQTDISPGERAL = 'S' AND @V_ITMAPURPREC_IDUTQTDISPFORN = 'S') BEGIN
               IF @V_QTSOLACOMP = 0 BEGIN
                  SET @V_QTSOLACOMP = @V_ITMAPURPREC_QTSOLACOMP;
                  SET @V_QTRESTANTE = @V_ITMAPURPREC_QTSOLACOMP;
               END
               ELSE BEGIN
                  IF @V_QTRESTANTE > 0 BEGIN
                     SET @V_QTSOLACOMP = (@V_QTRESTANTE/@V_ITMAPURPREC_VRFATOCONV);
                     IF (((CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_ITMAPURPREC_VRARREDCMP)  - (ROUND(@V_QTSOLACOMP / @V_ITMAPURPREC_VRARREDCMP, 0, 1))) <> 0) AND @V_ITMAPURPREC_VRARREDCMP > 0
                     BEGIN
                        SET @V_QTSOLACOMP = CEILING(CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_ITMAPURPREC_VRARREDCMP) * @V_ITMAPURPREC_VRARREDCMP;
                     END;
                     IF @V_IDCONSARREDCMPAPUR = 'S' BEGIN
                        SELECT @V_VRARREDEMPE = CASE ISNULL(MAX(VRARREDEMPE), 0)
                                                   WHEN 0
                                                   THEN 1
                                                   ELSE ISNULL(MAX(VRARREDEMPE), 0)
                                                END
                          FROM PRODFORNCOMP
                         WHERE CDFORNECED = @V_ITMAPURPREC_CDFORNITMAP
                           AND CDPRODUTO  = @V_ITMAPURPREC_CDPRODITMAP;
                        IF (((CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_VRARREDEMPE)  - (ROUND(@V_QTSOLACOMP / @V_VRARREDEMPE, 0, 1))) <> 0) AND @V_VRARREDEMPE > 0
                        BEGIN
                           SET @V_QTSOLACOMP = CEILING(CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_VRARREDEMPE) * @V_VRARREDEMPE;
                        END;
                     END;                     
                  END;
               END;

               IF @V_NRPEDIDOCOL IS NOT NULL BEGIN
                  SET @V_QTDEDISPONIVEL  = NULL;
                  SET @V_STRINGISPONIVEL = NULL;
                  SELECT @V_STRINGISPONIVEL = SUBSTRING(MAX(CDLISTA), 30, LEN(MAX(CDLISTA)))
                  FROM LISTA
                  WHERE NRLISTA = @V_LISTA
                    AND SUBSTRING(CDLISTA, 1, 29) = @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                                    @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP;
                  IF @V_STRINGISPONIVEL IS NULL BEGIN
                     SELECT @V_QTDEDISPONIVEL = MAX(QTDISPPRODMARC)
                     FROM PRMARCPEDCOL
                     WHERE PRMARCPEDCOL.CDFILIAL    = @V_ITMAPURPREC_CDCENTITMAP
                       AND PRMARCPEDCOL.NRPEDIDOCOL = @V_NRPEDIDOCOL
                       AND PRMARCPEDCOL.CDPRODUTO   = @V_ITMAPURPREC_CDPRODITMAP
                       AND PRMARCPEDCOL.CDMARCA     = @V_ITMAPURPREC_CDMARCITMAP;
                     IF @V_QTDEDISPONIVEL IS NOT NULL BEGIN
                         UPDATE LISTA
                         SET NRLISTA = @V_LISTA,
                             CDLISTA = @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                       @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP+CONVERT(VARCHAR, @V_QTDEDISPONIVEL)
                         WHERE NRLISTA = @V_LISTA
                           AND CDLISTA LIKE @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+@V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP+'%';
                         IF (NOT @@ROWCOUNT > 0) BEGIN
                            INSERT INTO LISTA (NRLISTA, CDLISTA)
                            VALUES(@V_LISTA,
                                   @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                   @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP+CONVERT(VARCHAR, @V_QTDEDISPONIVEL))
                         END;
                     END;
                  END
                  ELSE BEGIN
                     SET @V_QTDEDISPONIVEL = CONVERT(DOUBLE PRECISION, @V_STRINGISPONIVEL);
                  END;

                  IF @V_QTDEDISPONIVEL IS NOT NULL BEGIN
                     IF @V_QTDEDISPONIVEL >= @V_QTSOLACOMP BEGIN
                        SET @V_QTRESTANTE = 0;
                        SET @V_QTDEDISPONIVEL = @V_QTDEDISPONIVEL - @V_QTSOLACOMP;
                        UPDATE LISTA
                        SET CDLISTA = SUBSTRING(CDLISTA, 1, 29) + CONVERT(VARCHAR, @V_QTDEDISPONIVEL)
                        WHERE NRLISTA = @V_LISTA
                          AND SUBSTRING(CDLISTA, 1, 29) = @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                                          @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP;
                     END
                     ELSE BEGIN
                        SET @V_QTRESTANTE = (@V_QTSOLACOMP - @V_QTDEDISPONIVEL)*(@V_ITMAPURPREC_VRFATOCONV);
                        SET @V_QTSOLACOMP = @V_QTDEDISPONIVEL;
                        SET @V_QTDEDISPONIVEL = @V_QTDEDISPONIVEL - @V_QTSOLACOMP;
                        UPDATE LISTA
                        SET CDLISTA = SUBSTRING(CDLISTA, 1, 29) + CONVERT(VARCHAR, 0)
                        WHERE NRLISTA = @V_LISTA
                          AND SUBSTRING(CDLISTA, 1, 29) = @V_ITMAPURPREC_CDCENTITMAP+@V_NRPEDIDOCOL+
                                                          @V_ITMAPURPREC_CDPRODITMAP+@V_ITMAPURPREC_CDMARCITMAP;
                        IF (((CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_ITMAPURPREC_VRARREDCMP)  - (ROUND(@V_QTSOLACOMP / @V_ITMAPURPREC_VRARREDCMP, 0, 1))) <> 0) AND @V_ITMAPURPREC_VRARREDCMP > 0
                        BEGIN
                           SET @V_QTSOLACOMP = CEILING(CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_ITMAPURPREC_VRARREDCMP) * @V_ITMAPURPREC_VRARREDCMP;
                        END;
                        IF @V_IDCONSARREDCMPAPUR = 'S' BEGIN
                           SELECT @V_VRARREDEMPE = CASE ISNULL(MAX(VRARREDEMPE), 0)
                                                      WHEN 0
                                                      THEN 1
                                                      ELSE ISNULL(MAX(VRARREDEMPE), 0)
                                                   END
                             FROM PRODFORNCOMP
                            WHERE CDFORNECED = @V_ITMAPURPREC_CDFORNITMAP
                              AND CDPRODUTO  = @V_ITMAPURPREC_CDPRODITMAP;
                           IF (((CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_VRARREDEMPE)  - (ROUND(@V_QTSOLACOMP / @V_VRARREDEMPE, 0, 1))) <> 0) AND @V_VRARREDEMPE > 0
                           BEGIN
                              SET @V_QTSOLACOMP = CEILING(CAST(@V_QTSOLACOMP AS DOUBLE PRECISION) / @V_VRARREDEMPE) * @V_VRARREDEMPE;
                           END;
                        END;
                     END;
                  END
                  ELSE BEGIN
                     SET @V_QTRESTANTE = 0;
                  END;
               END
               ELSE BEGIN
                  SET @V_QTRESTANTE = 0;
               END;
               IF @V_QTSOLACOMP > 0 BEGIN
                  UPDATE ITMAPURPREC /* Escolhendo primeiro registro - APURA_MELHOR_COTACAO */
                  SET IDITMSELAPUR = 'S',
                      QTACOMP = @V_QTSOLACOMP,
                      IDMOTIVPRESC = @V_ITMAPURPREC_IDMOTIVPRESC
                  WHERE
                     CDCENTITMAP = @V_ITMAPURPREC_CDCENTITMAP AND
                     NRSEQITMAP  = @V_ITMAPURPREC_NRSEQITMAP  AND
                     CDREGITMAP  = @V_ITMAPURPREC_CDREGITMAP  AND
                     CDFORNITMAP = @V_ITMAPURPREC_CDFORNITMAP AND
                     NRCOLEITMAP = @V_ITMAPURPREC_NRCOLEITMAP AND
                     DTENTRAPUT  = @V_ITMAPURPREC_DTENTRAPUT  AND
                     CDFILIAP    = @V_ITMAPURPREC_CDFILIAP    AND
                     CDPRODITMAP = @V_ITMAPURPREC_CDPRODITMAP AND
                     CDMARCITMAP = @V_ITMAPURPREC_CDMARCITMAP;
               END;
            END
            ELSE BEGIN
               UPDATE ITMAPURPREC /* Escolhendo primeiro registro - APURA_MELHOR_COTACAO */
               SET IDITMSELAPUR = 'S',
                   QTACOMP      = QTSOLACOMP,
                   IDMOTIVPRESC = @V_ITMAPURPREC_IDMOTIVPRESC
               WHERE
                  CDCENTITMAP = @V_ITMAPURPREC_CDCENTITMAP AND
                  NRSEQITMAP  = @V_ITMAPURPREC_NRSEQITMAP  AND
                  CDREGITMAP  = @V_ITMAPURPREC_CDREGITMAP  AND
                  CDFORNITMAP = @V_ITMAPURPREC_CDFORNITMAP AND
                  NRCOLEITMAP = @V_ITMAPURPREC_NRCOLEITMAP AND
                  DTENTRAPUT  = @V_ITMAPURPREC_DTENTRAPUT  AND
                  CDFILIAP    = @V_ITMAPURPREC_CDFILIAP    AND
                  CDPRODITMAP = @V_ITMAPURPREC_CDPRODITMAP AND
                  CDMARCITMAP = @V_ITMAPURPREC_CDMARCITMAP;
            END;

            FETCH NEXT FROM C_ITMAPURPREC INTO @V_ITMAPURPREC_CDCENTITMAP,
                                               @V_ITMAPURPREC_NRSEQITMAP,
                                               @V_ITMAPURPREC_CDREGITMAP,
                                               @V_ITMAPURPREC_CDFORNITMAP,
                                               @V_ITMAPURPREC_NRCOLEITMAP,
                                               @V_ITMAPURPREC_DTENTRAPUT,
                                               @V_ITMAPURPREC_CDFILIAP,
                                               @V_ITMAPURPREC_CDPRODITMAP,
                                               @V_ITMAPURPREC_CDMARCITMAP,
                                               @V_ITMAPURPREC_VRFATOCONV,
                                               @V_ITMAPURPREC_VRARREDCMP,
                                               @V_ITMAPURPREC_QTSOLACOMP,
                                               @V_ITMAPURPREC_IDMOTIVPRESC,
                                               @V_ITMAPURPREC_IDUTQTDISPFORN;

            IF (@V_IDUTQTDISPGERAL = 'S' AND @V_ITMAPURPREC_IDUTQTDISPFORN = 'S') BEGIN
               IF @V_QTRESTANTE = 0 BEGIN
                  BREAK; /* Sai do Loop */
               END;
            END
            ELSE BEGIN
               BREAK; /* Sai do Loop */
            END;
          END;
          CLOSE C_ITMAPURPREC;
          DEALLOCATE C_ITMAPURPREC;
          FETCH NEXT FROM C_REGIAO INTO @V_REGIAO_CDREGITMAP,
                                        @V_REGIAO_CDPRODITMAP,
                                        @V_REGIAO_CDPRODESTO,
                                        @V_REGIAO_CDFILIAP,
                                        @V_REGIAO_DTENTRAPUT,
                                        @V_REGIAO_IDFUNCAOFILI,
                                        @V_REGIAO_CDPAIS,
                                        @V_REGIAO_SGESTADO,
                                        @V_REGIAO_CDMUNICIPIO;
     END;
     CLOSE C_REGIAO;
     DEALLOCATE C_REGIAO;
     DELETE FROM LISTA
     WHERE NRLISTA = @V_LISTA;
  END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'APURA_MELHOR_COTACAO','6.19.XXX';
GO
